net.sf.saxon.type

## Class ValidationException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - javax.xml.transform.TransformerException
      - - net.sf.saxon.trans.XPathException
        - - net.sf.saxon.type.ValidationException

- All Implemented Interfaces:
    Serializable, SourceLocator, Locator

      public class ValidationException
      extends XPathException
      implements SourceLocator, Locator

  This exception indicates a failure when validating an instance against a type defined in a schema.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.saxon.trans.XPathException

      `XPathException.Circularity`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ValidationException(Exception exception)` Creates a new ValidationException with the given nested exception.
    `ValidationException(String message)` Creates a new ValidationException with the given message.
    `ValidationException(String message, Exception exception)` Creates a new ValidationException with the given message and nested exception.
    `ValidationException(String message, SourceLocator locator)` Create a new ValidationException from a message and a Locator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AbsolutePath` | `getAbsolutePath()` Get the location of the error as a structured path object
    `int` | `getColumnNumber()`
    `String` | `getConstraintClauseNumber()` Get the constraint clause number
    `String` | `getConstraintName()` Get the constraint name
    `String` | `getConstraintReference()` Get the constraint name and clause in the format defined in XML Schema Part C (Outcome Tabulations).
    `String` | `getConstraintReferenceMessage()` Get the constraint reference as a string for inserting into an error message.
    `int` | `getConstraintSchemaPart()` Get the "schema part" component of the constraint reference
    `String` | `getContextLocationText()` Get additional location text, if any.
    `AbsolutePath` | `getContextPath()`
    `int` | `getLineNumber()`
    `SourceLocator` | `getLocator()`
    `NodeInfo` | `getNode()`
    `String` | `getPath()` Get the location of the error in terms of a path expressed as a string
    `String` | `getPublicId()`
    `SchemaType` | `getSchemaType()` Get the schema type against which validation was attempted and failed
    `String` | `getSystemId()`
    `String` | `getValidationLocationText()` Get additional location text, if any.
    `void` | `setColumnNumber(int column)`
    `void` | `setConstraintReference(int schemaPart, String constraintName, String clause)` Set a reference to the constraint in XML Schema that is not satisfied
    `void` | `setConstraintReference(ValidationException e)` Copy the constraint reference from another exception object
    `void` | `setContextPath(AbsolutePath path)`
    `void` | `setLineNumber(int line)`
    `void` | `setLocator(Locator locator)`
    `void` | `setNode(NodeInfo node)`
    `void` | `setPath(AbsolutePath path)` Set the path in the source document
    `void` | `setPublicId(String id)`
    `void` | `setSchemaType(SchemaType type)` Set the schema type against which validation was attempted and failed
    `void` | `setSourceLocator(SourceLocator locator)`
    `void` | `setSystemId(String id)`
    `String` | `toString()` Returns the String representation of this Exception

    - ### Methods inherited from class net.sf.saxon.trans.XPathException

      `getAdditionalLocationText, getErrorCodeLocalPart, getErrorCodeNamespace, getErrorCodeQName, getErrorObject, getXPathContext, hasBeenReported, isGlobalError, isReportableStatically, isStaticError, isTypeError, makeStatic, makeXPathException, maybeSetContext, maybeSetErrorCode, maybeSetLocation, setAdditionalLocationText, setErrorCode, setErrorCodeQName, setErrorObject, setHasBeenReported, setIsGlobalError, setIsStaticError, setIsTypeError, setXPathContext`

    - ### Methods inherited from class javax.xml.transform.TransformerException

      `getCause, getException, getLocationAsString, getMessageAndLocation, initCause, printStackTrace, printStackTrace, printStackTrace, setLocator`

    - ### Methods inherited from class java.lang.Throwable

      `addSuppressed, fillInStackTrace, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, setStackTrace`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ValidationException

          public ValidationException(String message)

      Creates a new ValidationException with the given message.
      Parameters:
        `message` - the message for this Exception

    - #### ValidationException

          public ValidationException(Exception exception)

      Creates a new ValidationException with the given nested exception.
      Parameters:
        `exception` - the nested exception

    - #### ValidationException

          public ValidationException(String message,
                             Exception exception)

      Creates a new ValidationException with the given message and nested exception.
      Parameters:
        `message` - the detail message for this exception
        `exception` - the nested exception

    - #### ValidationException

          public ValidationException(String message,
                             SourceLocator locator)

      Create a new ValidationException from a message and a Locator.
      Parameters:
        `message` - The error or warning message.
        `locator` - The locator object for the error or warning.

  - ### Method Detail

    - #### setConstraintReference

          public void setConstraintReference(int schemaPart,
                                    String constraintName,
                                    String clause)

      Set a reference to the constraint in XML Schema that is not satisfied
      Parameters:
        `schemaPart` - - 1 or 2, depending whether the constraint is in XMLSchema part 1 or part 2
        `constraintName` - - the short name of the constraint in XMLSchema, as a fragment identifier in the HTML of the XML Schema Part 1 specification
        `clause` - - the clause number within the description of that constraint

    - #### setConstraintReference

          public void setConstraintReference(ValidationException e)

      Copy the constraint reference from another exception object
      Parameters:
        `e` - the other exception object from which to copy the information

    - #### getConstraintReferenceMessage

          public String getConstraintReferenceMessage()

      Get the constraint reference as a string for inserting into an error message.
      Returns:
        the reference as a message, or null if no information is available

    - #### getConstraintSchemaPart

          public int getConstraintSchemaPart()

      Get the "schema part" component of the constraint reference
      Returns:
        1 or 2 depending on whether the violated constraint is in XML Schema Part 1 or Part 2; or -1 if there is no constraint reference

    - #### getConstraintName

          public String getConstraintName()

      Get the constraint name
      Returns:
        the name of the violated constraint, in the form of a fragment identifier within the published XML Schema specification; or null if the information is not available.

    - #### getConstraintClauseNumber

          public String getConstraintClauseNumber()

      Get the constraint clause number
      Returns:
        the section number of the clause containing the constraint that has been violated. Generally a decimal number in the form n.n.n; possibly a sequence of such numbers separated by semicolons. Or null if the information is not available.

    - #### getConstraintReference

          public String getConstraintReference()

      Get the constraint name and clause in the format defined in XML Schema Part C (Outcome Tabulations). This mandates the format validation-rule-name.clause-number
      Returns:
        the constraint reference, for example "cos-ct-extends.1.2"; or null if the reference is not known.

    - #### setPath

          public void setPath(AbsolutePath path)

      Set the path in the source document
      Parameters:
        `path` - the path to the invalid element in the source document

    - #### toString

          public String toString()

      Returns the String representation of this Exception
      Overrides:
        `toString` in class `Throwable`
      Returns:
        the String representation of this Exception

    - #### getPublicId

          public String getPublicId()

      Specified by:
        `getPublicId` in interface `SourceLocator`
      Specified by:
        `getPublicId` in interface `Locator`

    - #### getSystemId

          public String getSystemId()

      Specified by:
        `getSystemId` in interface `SourceLocator`
      Specified by:
        `getSystemId` in interface `Locator`

    - #### getLineNumber

          public int getLineNumber()

      Specified by:
        `getLineNumber` in interface `SourceLocator`
      Specified by:
        `getLineNumber` in interface `Locator`

    - #### getColumnNumber

          public int getColumnNumber()

      Specified by:
        `getColumnNumber` in interface `SourceLocator`
      Specified by:
        `getColumnNumber` in interface `Locator`

    - #### getNode

          public NodeInfo getNode()

    - #### getPath

          public String getPath()

      Get the location of the error in terms of a path expressed as a string
      Returns:
        the location, as a path. The result format is similar to that of the fn:path() function

    - #### getAbsolutePath

          public AbsolutePath getAbsolutePath()

      Get the location of the error as a structured path object
      Returns:
        the location, as a structured path object indicating the position of the error within the containing document

    - #### setPublicId

          public void setPublicId(String id)

    - #### setSystemId

          public void setSystemId(String id)

    - #### setLineNumber

          public void setLineNumber(int line)

    - #### setColumnNumber

          public void setColumnNumber(int column)

    - #### setLocator

          public void setLocator(Locator locator)

    - #### setSourceLocator

          public void setSourceLocator(SourceLocator locator)

    - #### setNode

          public void setNode(NodeInfo node)

    - #### getLocator

          public SourceLocator getLocator()

      Overrides:
        `getLocator` in class `TransformerException`

    - #### setContextPath

          public void setContextPath(AbsolutePath path)

    - #### getContextPath

          public AbsolutePath getContextPath()

    - #### getValidationLocationText

          public String getValidationLocationText()

      Get additional location text, if any. This gives extra information about the position of the error in textual form. Where XPath is embedded within a host language such as XSLT, the formal location information identifies the location of the error in the XSLT module, while this string locates the error within a specific XPath expression. The information is typically used only for static errors.
      Returns:
        additional information about the location of the error, designed to be output as a prefix to the error message if desired. (It is not concatenated with the message, because it may be superfluous in an IDE environment.)

    - #### getContextLocationText

          public String getContextLocationText()

      Get additional location text, if any. This gives extra information about the position of the error in textual form. Where XPath is embedded within a host language such as XSLT, the formal location information identifies the location of the error in the XSLT module, while this string locates the error within a specific XPath expression. The information is typically used only for static errors.
      Returns:
        additional information about the location of the error, designed to be output as a prefix to the error message if desired. (It is not concatenated with the message, because it may be superfluous in an IDE environment.)

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the schema type against which validation was attempted and failed
      Returns:
        the relevant schema type if available, or null otherwise

    - #### setSchemaType

          public void setSchemaType(SchemaType type)

      Set the schema type against which validation was attempted and failed
      Parameters:
        `type` - the relevant schema type if available, or null otherwise

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.